//$Id: ManyToOne.java,v 1.12 2005/04/28 08:35:10 oneovthafew Exp $
package org.hibernate.mapping;

import org.hibernate.MappingException;
import org.hibernate.type.EntityType;
import org.hibernate.type.Type;
import org.hibernate.type.TypeFactory;

/**
 * A many-to-one association mapping
 * @author Gavin King
 */
public class ManyToOne extends ToOne {
	
	private boolean ignoreNotFound;

	public ManyToOne(Table table) {
		super(table);
	}

	public Type getType() throws MappingException {
		return TypeFactory.manyToOne( 
			getReferencedEntityName(), 
			getReferencedPropertyName(),
			isLazy(),
			isEmbedded(),
			isIgnoreNotFound() );
	}

	public void createForeignKey() throws MappingException {
		// TODO: handle the case of a foreign key to something other than the pk
		if (referencedPropertyName==null && !hasFormula() ) {
			createForeignKeyOfEntity( ( (EntityType) getType() ).getAssociatedEntityName() );
		}
	}

	public Object accept(ValueVisitor visitor) {
		return visitor.accept(this);
	}

	public boolean isIgnoreNotFound() {
		return ignoreNotFound;
	}

	public void setIgnoreNotFound(boolean ignoreNotFound) {
		this.ignoreNotFound = ignoreNotFound;
	}
	
}
