//$Id: JACCPreDeleteEventListener.java,v 1.5 2005/04/03 18:28:28 oneovthafew Exp $
package org.hibernate.secure;

import java.security.AccessController;

import javax.security.jacc.EJBMethodPermission;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.event.PreDeleteEvent;
import org.hibernate.event.def.DefaultPreDeleteEventListener;

/**
 * @author Gavin King
 */
public class JACCPreDeleteEventListener extends DefaultPreDeleteEventListener {
	
	private static final Log log = LogFactory.getLog(JACCPreDeleteEventListener.class);

	public boolean onPreDelete(PreDeleteEvent event) {
		EJBMethodPermission deletePermission = new EJBMethodPermission( 
				event.getPersister().getEntityName(),
				HibernatePermission.DELETE
		);
		log.debug( "checking delete permission on: " + deletePermission.getName() );
		AccessController.checkPermission(deletePermission);
		return super.onPreDelete(event);
	}
}
