//$Id: JACCPreInsertEventListener.java,v 1.5 2005/04/03 18:28:28 oneovthafew Exp $
package org.hibernate.secure;

import java.security.AccessController;

import javax.security.jacc.EJBMethodPermission;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.event.PreInsertEvent;
import org.hibernate.event.def.DefaultPreInsertEventListener;

/**
 * @author Gavin King
 */
public class JACCPreInsertEventListener extends DefaultPreInsertEventListener {

	private static final Log log = LogFactory.getLog(JACCPreInsertEventListener.class);

	public boolean onPreInsert(PreInsertEvent event) {
		EJBMethodPermission insertPermission = new EJBMethodPermission( 
				event.getPersister().getEntityName(),
				HibernatePermission.INSERT
		);
		log.debug( "checking insert permission on: " + insertPermission.getName() );
		AccessController.checkPermission(insertPermission);
		return super.onPreInsert(event);
	}
}
