//$Id: JDBCTransactionFactory.java,v 1.4 2005/05/04 00:13:26 oneovthafew Exp $
package org.hibernate.transaction;

import java.util.Properties;

import org.hibernate.ConnectionReleaseMode;
import org.hibernate.Transaction;
import org.hibernate.HibernateException;
import org.hibernate.jdbc.JDBCContext;

/**
 * Factory for <tt>JDBCTransaction</tt>.
 * @see JDBCTransaction
 * @author Anton van Straaten
 */
public final class JDBCTransactionFactory implements TransactionFactory {

	public ConnectionReleaseMode getDefaultReleaseMode() {
		return ConnectionReleaseMode.AFTER_TRANSACTION;
	}

	public Transaction beginTransaction(JDBCContext jdbcContext, Context transactionContext) throws HibernateException {
		JDBCTransaction tx = new JDBCTransaction( jdbcContext, transactionContext );
		tx.begin();
		return tx;
	}

	public void configure(Properties props) throws HibernateException {}

}
